﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SilverlightApplication5.Enums;
using System.Windows.Interop;

namespace SilverlightApplication5
{
  public static class AppContext
  {
    public static AppContextStatus CurrentStatus
    {
      get
      {
        AppContextStatus status =
          Application.Current.IsRunningOutOfBrowser ?
            AppContextStatus.OutOfBrowser : AppContextStatus.InBrowser;

        if ((status & AppContextStatus.OutOfBrowser) != 0)
        {
          if (Application.Current.HasElevatedPermissions)
          {
            status |= AppContextStatus.OutOfBrowserTrusted;
          }
          if (ComAutomationFactory.IsAvailable)
          {
            status |= AppContextStatus.OutOfBrowserCOMInterop;
          }
        }
        return (status);
      }
    }
  }
}