﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel.Composition.Primitives;
using System.Linq;
using SilverlightApplication5.Enums;
using System.ComponentModel.Composition.Hosting;
using System.Collections.Generic;

namespace SilverlightApplication5
{
  //public class Foo : ComposablePartExportProvider
  //{
  //  ExportProvider provider;
  //  public Foo(ExportProvider provider)
  //  {
  //    this.provider = provider;
  //  }
  //  protected override IEnumerable<Export> GetExportsCore(
  //    ImportDefinition definition, AtomicComposition atomicComposition)
  //  {
  //    AppContextStatus appStatus = AppContext.CurrentStatus;

  //    return (this.provider.GetExports(definition, atomicComposition).Where(
  //      e =>
  //          (e.Metadata.ContainsKey(AppContextConstants.AppContextKey) &&
  //          (((AppContextStatus)e.Metadata[AppContextConstants.AppContextKey] & appStatus) != 0))
  //        ||
  //          !e.Metadata.ContainsKey(AppContextConstants.AppContextKey)));
  //  }
  //}
  public class AppContextCatalog : ComposablePartCatalog
  {
    public AppContextCatalog(ComposablePartCatalog innerCatalog)
    {
      this.innerCatalog = innerCatalog;
    }
    public override IQueryable<ComposablePartDefinition> Parts
    {
      get
      {
        AppContextStatus appStatus = AppContext.CurrentStatus;

        var query =
          from p in this.innerCatalog.Parts
          where 
            (
              p.Metadata.ContainsKey(AppContextConstants.AppContextKey) &&
                (((AppContextStatus)p.Metadata[AppContextConstants.AppContextKey] & 
                  appStatus) != 0)
            ) || 
            (
              !p.Metadata.ContainsKey(AppContextConstants.AppContextKey)
            )            
          select p;

        return (query);
      }
    }
    ComposablePartCatalog innerCatalog;
  }
}
