﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel.Composition;
using SilverlightApplication5.Interfaces;

namespace SilverlightApplication5
{
  public partial class MainPage : UserControl
  {
    [ImportMany]
    public IEnumerable<IView> Views { get; set; }

    public IEnumerable<TabItem> Tabs
    {
      get
      {
        return (this.Views.Select(
          (v, i) =>
            new TabItem()
            {
              Header = string.Format("View {0}", i),
              Content = v
            }));
      }
    }

    public MainPage()
    {
      InitializeComponent();

      PartInitializer.SatisfyImports(this);

      this.Loaded += (s, e) =>
        {
          this.DataContext = this;
        };
    }
  }
}
